unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, Classes;

type

  { TForm1 }

  TForm1 = class(TForm)
    ImageList1Switch: TImageList;
    ImageList1Puk: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    Puk: TImage;
    Puk1: TImage;
    Switch: TImage;
    ImageListPuk: TImageList;
    ImageListSwitch: TImageList;
    Switch1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure SwitchClick(Sender: TObject);
    procedure PukClick(Sender: TObject);
    procedure Switch1Click(Sender: TObject);
    procedure Puk1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.SwitchClick(Sender: TObject);
var
  i: Integer;
begin
  if Switch.Tag = 0 then
  begin
    for i := Switch.Left to Switch.Left + (Switch.Width - Puk.Width) do
    begin
      Puk.Left := i;
      Sleep(1);
      Puk.Repaint;
      //Application.ProcessMessages;
    end;
    Switch.Tag := 1;
    ImageListSwitch.GetBitmap(Switch.Tag,Switch.Picture.Bitmap);
    Puk.Tag := 1;
    ImageListPuk.GetBitmap(Puk.Tag,Puk.Picture.Bitmap);
  end
  else
  begin
    for i := Switch.Left + (Switch.Width - Puk.Width) downto Switch.Left do
    begin
      Puk.Left := i;
      Sleep(1);
      Puk.Repaint;
      //Application.ProcessMessages;
    end;
    Switch.Tag := 0;
    ImageListSwitch.GetBitmap(Switch.Tag,Switch.Picture.Bitmap);
    Puk.Tag := 0;
    ImageListPuk.GetBitmap(Puk.Tag,Puk.Picture.Bitmap);
  end;

  if Switch.Tag = 0 then
    Label1.Caption := 'Der Schalter ist ausgeschaltet.'
  else
    Label1.Caption := 'Der Schalter ist eingeschaltet.';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Switch.Tag := 0;
  ImageListSwitch.GetBitmap(Switch.Tag,Switch.Picture.Bitmap);

  Puk.Tag := 0;
  ImageListPuk.GetBitmap(Puk.Tag,Puk.Picture.Bitmap);

  Switch1.Tag := 0;
  ImageList1Switch.GetBitmap(Switch1.Tag,Switch1.Picture.Bitmap);

  Puk1.Tag := 0;
  ImageList1Puk.GetBitmap(Puk1.Tag,Puk1.Picture.Bitmap);

end;

procedure TForm1.PukClick(Sender: TObject);
begin
  SwitchClick(Self);
end;

procedure TForm1.Switch1Click(Sender: TObject);
var
  i: Integer;
begin
  if Switch1.Tag = 0 then
  begin
    for i := Switch1.Left to Switch1.Left + (Switch1.Width - Puk1.Width) do
    begin
      Puk1.Left := i;
      Sleep(1);
      Puk.Repaint;
      //Application.ProcessMessages;
    end;
    Switch1.Tag := 1;
    ImageList1Switch.GetBitmap(Switch1.Tag,Switch1.Picture.Bitmap);
  end
  else
  begin
    for i := Switch1.Left + (Switch1.Width - Puk1.Width) downto Switch1.Left do
    begin
      Puk1.Left := i;
      Sleep(1);
      Puk.Repaint;
      //Application.ProcessMessages;
    end;
    Switch1.Tag := 0;
    ImageList1Switch.GetBitmap(Switch1.Tag,Switch1.Picture.Bitmap);
  end;

  if Switch1.Tag = 0 then
    Label2.Caption := 'Der Schalter ist ausgeschaltet.'
  else
    Label2.Caption := 'Der Schalter ist eingeschaltet.';
end;

procedure TForm1.Puk1Click(Sender: TObject);
begin
  Switch1Click(Self);
end;

end.
